diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/Makefile.am leptonlib-1.066/src/Makefile.am
--- leptonlib-1.66/src/Makefile.am	2010-08-03 01:27:48.000000000 +0300
+++ leptonlib-1.066/src/Makefile.am	2010-09-30 11:32:11.000000000 +0300
@@ -67,9 +67,10 @@
  seedfill.c seedfilllow.c \
  sel1.c sel2.c selgen.c \
  shear.c skew.c spixio.c \
- stack.c textops.c \
+ stack.c sudoku.c textops.c \
  tiffio.c tiffiostub.c \
  utils.c viewfiles.c \
+ webpio.c webpiostub.c \
  warper.c watershed.c writefile.c \
  zlibmem.c zlibmemstub.c
 
@@ -77,7 +78,7 @@
  arrayaccess.h bbuffer.h bmf.h bmp.h ccbord.h dewarp.h environ.h \
  gplot.h heap.h imageio.h jbclass.h leptprotos.h list.h \
  morph.h pix.h ptra.h queue.h readbarcode.h regutils.h \
- stack.h watershed.h
+ stack.h sudoku.h watershed.h
 
 EXTRA_DIST = Makefile.mingw arrayaccess.h.vc arrayaccess.h.vc60 \
  endiantest.c hmttemplate1.txt hmttemplate2.txt leptonica-license.txt \
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/alltypes.h leptonlib-1.066/src/alltypes.h
--- leptonlib-1.66/src/alltypes.h	2010-07-09 03:45:09.000000000 +0300
+++ leptonlib-1.066/src/alltypes.h	2010-08-16 09:02:35.000000000 +0300
@@ -35,6 +35,7 @@
 #include "queue.h"
 #include "regutils.h"
 #include "stack.h"
+#include "sudoku.h"
 #include "watershed.h"
 
     /* i/o */
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/arrayaccess.h leptonlib-1.066/src/arrayaccess.h
--- leptonlib-1.66/src/arrayaccess.h	2010-07-31 04:05:27.000000000 +0300
+++ leptonlib-1.066/src/arrayaccess.h	2010-09-10 23:32:58.000000000 +0300
@@ -47,7 +47,11 @@
  */
 
 
-#if 1   /* Inline Accessors */
+    /* Use the inline accessors (except with _MSC_VER), because they
+     * are faster.  */
+#define  USE_INLINE_ACCESSORS    1
+
+#if USE_INLINE_ACCESSORS
 #ifndef _MSC_VER
 
     /*--------------------------------------------------*
@@ -155,14 +159,14 @@
 
 
 #endif  /* ! _MSC_VER */
-#endif  /* Inline Accessors */
+#endif  /* USE_INLINE_ACCESSORS */
 
 
 
     /*--------------------------------------------------*
      *  Slower, using function calls for all accessors  *
      *--------------------------------------------------*/
-#if 0 || defined(_MSC_VER)
+#if !USE_INLINE_ACCESSORS || defined(_MSC_VER)
 #define  GET_DATA_BIT(pdata, n)               l_getDataBit(pdata, n)
 #define  SET_DATA_BIT(pdata, n)               l_setDataBit(pdata, n)
 #define  CLEAR_DATA_BIT(pdata, n)             l_clearDataBit(pdata, n)
@@ -184,7 +188,7 @@
 
 #define  GET_DATA_FOUR_BYTES(pdata, n)         l_getDataFourBytes(pdata, n)
 #define  SET_DATA_FOUR_BYTES(pdata, n, val)    l_setDataFourBytes(pdata, n, val)
-#endif
+#endif  /* !USE_INLINE_ACCESSORS || _MSC_VER */
 
 
 #endif /* LEPTONICA_ARRAY_ACCESS_H */
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/bmpio.c leptonlib-1.066/src/bmpio.c
--- leptonlib-1.66/src/bmpio.c	2010-07-20 00:02:17.000000000 +0300
+++ leptonlib-1.066/src/bmpio.c	2010-09-16 08:18:29.000000000 +0300
@@ -57,7 +57,7 @@
 l_uint32   ival;
 l_int16    bfType, bfSize, bfFill1, bfReserved1, bfReserved2;
 l_int16    offset, bfFill2, biPlanes, depth, d;
-l_int32    biSize, width, height, xres, yres, compression;
+l_int32    biSize, width, height, xres, yres, compression, ignore;
 l_int32    imagebytes, biClrUsed, biClrImportant;
 l_uint8   *colormapBuf;
 l_int32    colormapEntries;
@@ -76,46 +76,46 @@
         return (PIX *)ERROR_PTR("fp not defined", procName, NULL);
 
         /* Read bitmap file header */
-    fread((char *)&sval, 1, 2, fp);
+    ignore = fread((char *)&sval, 1, 2, fp);
     bfType = convertOnBigEnd16(sval);
     if (bfType != BMP_ID)
         return (PIX *)ERROR_PTR("not bmf format", procName, NULL);
 
-    fread((char *)&sval, 1, 2, fp);
+    ignore = fread((char *)&sval, 1, 2, fp);
     bfSize = convertOnBigEnd16(sval);
-    fread((char *)&sval, 1, 2, fp);
+    ignore = fread((char *)&sval, 1, 2, fp);
     bfFill1 = convertOnBigEnd16(sval);
-    fread((char *)&sval, 1, 2, fp);
+    ignore = fread((char *)&sval, 1, 2, fp);
     bfReserved1 = convertOnBigEnd16(sval);
-    fread((char *)&sval, 1, 2, fp);
+    ignore = fread((char *)&sval, 1, 2, fp);
     bfReserved2 = convertOnBigEnd16(sval);
-    fread((char *)&sval, 1, 2, fp);
+    ignore = fread((char *)&sval, 1, 2, fp);
     offset = convertOnBigEnd16(sval);
-    fread((char *)&sval, 1, 2, fp);
+    ignore = fread((char *)&sval, 1, 2, fp);
     bfFill2 = convertOnBigEnd16(sval);
 
         /* Read bitmap info header */
-    fread((char *)&ival, 1, 4, fp);
+    ignore = fread((char *)&ival, 1, 4, fp);
     biSize = convertOnBigEnd32(ival);
-    fread((char *)&ival, 1, 4, fp);
+    ignore = fread((char *)&ival, 1, 4, fp);
     width = convertOnBigEnd32(ival);
-    fread((char *)&ival, 1, 4, fp);
+    ignore = fread((char *)&ival, 1, 4, fp);
     height = convertOnBigEnd32(ival);
-    fread((char *)&sval, 1, 2, fp);
+    ignore = fread((char *)&sval, 1, 2, fp);
     biPlanes = convertOnBigEnd16(sval);
-    fread((char *)&sval, 1, 2, fp);
+    ignore = fread((char *)&sval, 1, 2, fp);
     depth = convertOnBigEnd16(sval);
-    fread((char *)&ival, 1, 4, fp);
+    ignore = fread((char *)&ival, 1, 4, fp);
     compression = convertOnBigEnd32(ival);
-    fread((char *)&ival, 1, 4, fp);
+    ignore = fread((char *)&ival, 1, 4, fp);
     imagebytes = convertOnBigEnd32(ival);
-    fread((char *)&ival, 1, 4, fp);
+    ignore = fread((char *)&ival, 1, 4, fp);
     xres = convertOnBigEnd32(ival);
-    fread((char *)&ival, 1, 4, fp);
+    ignore = fread((char *)&ival, 1, 4, fp);
     yres = convertOnBigEnd32(ival);
-    fread((char *)&ival, 1, 4, fp);
+    ignore = fread((char *)&ival, 1, 4, fp);
     biClrUsed = convertOnBigEnd32(ival);
-    fread((char *)&ival, 1, 4, fp);
+    ignore = fread((char *)&ival, 1, 4, fp);
     biClrImportant = convertOnBigEnd32(ival);
 
     if (compression != 0)
@@ -242,7 +242,7 @@
             }
             if (extrabytes) {
                 for (k = 0; k < extrabytes; k++)
-                    fread(&pel, 1, 1, fp);
+                    ignore = fread(&pel, 1, 1, fp);
             }
             line -= pixWpl;
         }
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/colormap.c leptonlib-1.066/src/colormap.c
--- leptonlib-1.66/src/colormap.c	2010-07-22 14:44:24.000000000 +0300
+++ leptonlib-1.066/src/colormap.c	2010-09-15 22:36:42.000000000 +0300
@@ -1171,7 +1171,7 @@
 PIXCMAP *
 pixcmapReadStream(FILE  *fp)
 {
-l_int32   rval, gval, bval;
+l_int32   rval, gval, bval, ignore;
 l_int32   i, index, ret, depth, ncolors;
 PIXCMAP  *cmap;
 
@@ -1186,14 +1186,14 @@
         (depth != 1 && depth != 2 && depth != 4 && depth != 8) ||
         (ncolors < 2 || ncolors > 256))
         return (PIXCMAP *)ERROR_PTR("invalid cmap size", procName, NULL);
-    fscanf(fp, "Color    R-val    G-val    B-val\n");
-    fscanf(fp, "--------------------------------\n");
+    ignore = fscanf(fp, "Color    R-val    G-val    B-val\n");
+    ignore = fscanf(fp, "--------------------------------\n");
 
     if ((cmap = pixcmapCreate(depth)) == NULL)
         return (PIXCMAP *)ERROR_PTR("cmap not made", procName, NULL);
     for (i = 0; i < ncolors; i++) {
-        fscanf(fp, "%3d       %3d      %3d      %3d\n",
-                &index, &rval, &gval, &bval);
+        ignore = fscanf(fp, "%3d       %3d      %3d      %3d\n",
+                        &index, &rval, &gval, &bval);
         pixcmapAddColor(cmap, rval, gval, bval);
     }
 
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/environ.h leptonlib-1.066/src/environ.h
--- leptonlib-1.66-orig/src/environ.h   2010-08-01 23:20:20.000000000 +0300
+++ leptonlib-1.66/src/environ.h        2010-10-16 23:06:51.000000000 +0300
@@ -94,6 +94,7 @@
 #define  HAVE_LIBZ        1
 #define  HAVE_LIBGIF      0
 #define  HAVE_LIBUNGIF    0
+#define  HAVE_LIBWEBP     1
 #endif  /* ~HAVE_CONFIG_H */
 
 /*
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/gifio.c leptonlib-1.066/src/gifio.c
--- leptonlib-1.66/src/gifio.c	2010-08-02 08:36:18.000000000 +0300
+++ leptonlib-1.066/src/gifio.c	2010-09-08 00:13:10.000000000 +0300
@@ -16,8 +16,11 @@
 /*
  *  gifio.c
  *
- *    Read/write gif to file
+ *    Read gif from file
  *          PIX        *pixReadStreamGif()
+ *          static PIX *pixInterlaceGIF()
+ *
+ *    Write gif to file
  *          l_int32     pixWriteStreamGif()
  *
  *    Read/write from/to memory
@@ -51,6 +54,12 @@
 
 #include "gif_lib.h"
 
+    /* GIF supports 4-way horizontal interlacing */
+static PIX * pixInterlaceGIF(PIX  *pixs);
+static const l_int32 InterlacedOffset[] = {0, 4, 2, 1};
+static const l_int32 InterlacedJumps[] = {8, 8, 4, 2};
+
+
 /*---------------------------------------------------------------------*
  *                       Reading gif from file                         *
  *---------------------------------------------------------------------*/
@@ -67,7 +76,7 @@
 l_int32          rval, gval, bval;
 l_uint32        *data, *line;
 GifFileType     *gif;
-PIX             *pixd;
+PIX             *pixd, *pixdi;
 PIXCMAP         *cmap;
 ColorMapObject  *gif_cmap;
 SavedImage       si;
@@ -154,7 +163,7 @@
     data = pixGetData(pixd);
     for (i = 0; i < h; i++) {
         line = data + i * wpl;
-	if (d == 1) {
+        if (d == 1) {
             for (j = 0; j < w; j++) {
                 if (si.RasterBits[i * w + j])
                     SET_DATA_BIT(line, j);
@@ -174,11 +183,47 @@
         }
     }
 
+    if (gif->Image.Interlace) {
+        pixdi = pixInterlaceGIF(pixd);
+        pixTransferAllData(pixd, &pixdi, 0, 0);
+    }
+
     DGifCloseFile(gif);
     return pixd;
 }
 
 
+static PIX *
+pixInterlaceGIF(PIX  *pixs)
+{
+l_int32    w, h, d, wpl, j, k, srow, drow;
+l_uint32  *datas, *datad, *lines, *lined;
+PIX       *pixd;
+
+    PROCNAME("pixInterlaceGIF");
+
+    if (!pixs)
+        return (PIX *)ERROR_PTR("pixs not defined", procName, NULL);
+
+    pixGetDimensions(pixs, &w, &h, &d);
+    wpl = pixGetWpl(pixs);
+    pixd = pixCreateTemplate(pixs);
+    datas = pixGetData(pixs);
+    datad = pixGetData(pixd);
+    for (k = 0, srow = 0; k < 4; k++) {
+        for (drow = InterlacedOffset[k]; drow < h;
+             drow += InterlacedJumps[k], srow++) {
+            lines = datas + srow * wpl;
+            lined = datad + drow * wpl;
+            for (j = 0; j < w; j++)
+                memcpy(lined, lines, 4 * wpl);
+        }
+    }
+
+    return pixd;
+}
+
+
 /*---------------------------------------------------------------------*
  *                         Writing gif to file                         *
  *---------------------------------------------------------------------*/
@@ -267,7 +312,7 @@
         return ERROR_INT("failed to create GIF color map", procName, 1);
     }
     for (i = 0; i < gif_ncolor; i++) {
-	rval = gval = bval = 0;
+        rval = gval = bval = 0;
         if (ncolor > 0) {
             if (pixcmapGetColor(cmap, i, &rval, &gval, &bval) != 0) {
                 pixDestroy(&pixd);
@@ -443,7 +488,7 @@
     *psize = nbytes;
     return 0;
 }
-    
+
 
 /* -----------------------------------------------------------------*/
 #endif    /* HAVE_LIBGIF || HAVE_LIBUNGIF  */
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/gplot.c leptonlib-1.066/src/gplot.c
--- leptonlib-1.66/src/gplot.c	2010-08-02 20:01:27.000000000 +0300
+++ leptonlib-1.066/src/gplot.c	2010-09-15 22:36:44.000000000 +0300
@@ -349,7 +349,8 @@
 l_int32
 gplotMakeOutput(GPLOT  *gplot)
 {
-char  buf[L_BUF_SIZE];
+char     buf[L_BUF_SIZE];
+l_int32  ignore;
 
     PROCNAME("gplotMakeOutput");
 
@@ -372,7 +373,7 @@
        snprintf(buf, L_BUF_SIZE,
                "wgnuplot -persist %s", gplot->cmdname);
 #endif  /* _WIN32 */
-    system(buf);
+    ignore = system(buf);
     return 0;
 }
 
@@ -676,8 +677,8 @@
 gplotRead(const char  *filename)
 {
 char     buf[L_BUF_SIZE];
-char    *rootname, *title, *xlabel, *ylabel;
-l_int32  outformat, ret, version;
+char    *rootname, *title, *xlabel, *ylabel, *ignores;
+l_int32  outformat, ret, version, ignore;
 FILE    *fp;
 GPLOT   *gplot;
 
@@ -699,16 +700,16 @@
         return (GPLOT *)ERROR_PTR("invalid gplot version", procName, NULL);
     }
 
-    fscanf(fp, "Rootname: %s\n", buf);
+    ignore = fscanf(fp, "Rootname: %s\n", buf);
     rootname = stringNew(buf);
-    fscanf(fp, "Output format: %d\n", &outformat);
-    fgets(buf, L_BUF_SIZE, fp);   /* Title: ... */
+    ignore = fscanf(fp, "Output format: %d\n", &outformat);
+    ignores = fgets(buf, L_BUF_SIZE, fp);   /* Title: ... */
     title = stringNew(buf + 7);
     title[strlen(title) - 1] = '\0';
-    fgets(buf, L_BUF_SIZE, fp);   /* X axis label: ... */
+    ignores = fgets(buf, L_BUF_SIZE, fp);   /* X axis label: ... */
     xlabel = stringNew(buf + 14);
     xlabel[strlen(xlabel) - 1] = '\0';
-    fgets(buf, L_BUF_SIZE, fp);   /* Y axis label: ... */
+    ignores = fgets(buf, L_BUF_SIZE, fp);   /* Y axis label: ... */
     ylabel = stringNew(buf + 14);
     ylabel[strlen(ylabel) - 1] = '\0';
 
@@ -726,23 +727,23 @@
     sarrayDestroy(&gplot->plottitles);
     numaDestroy(&gplot->plotstyles);
 
-    fscanf(fp, "Commandfile name: %s\n", buf);
+    ignore = fscanf(fp, "Commandfile name: %s\n", buf);
     stringReplace(&gplot->cmdname, buf);
-    fscanf(fp, "\nCommandfile data:");
+    ignore = fscanf(fp, "\nCommandfile data:");
     gplot->cmddata = sarrayReadStream(fp);
-    fscanf(fp, "\nDatafile names:");
+    ignore = fscanf(fp, "\nDatafile names:");
     gplot->datanames = sarrayReadStream(fp);
-    fscanf(fp, "\nPlot data:");
+    ignore = fscanf(fp, "\nPlot data:");
     gplot->plotdata = sarrayReadStream(fp);
-    fscanf(fp, "\nPlot titles:");
+    ignore = fscanf(fp, "\nPlot titles:");
     gplot->plottitles = sarrayReadStream(fp);
-    fscanf(fp, "\nPlot styles:");
+    ignore = fscanf(fp, "\nPlot styles:");
     gplot->plotstyles = numaReadStream(fp);
 
-    fscanf(fp, "Number of plots: %d\n", &gplot->nplots);
-    fscanf(fp, "Output file name: %s\n", buf);
+    ignore = fscanf(fp, "Number of plots: %d\n", &gplot->nplots);
+    ignore = fscanf(fp, "Output file name: %s\n", buf);
     stringReplace(&gplot->outname, buf);
-    fscanf(fp, "Axis scaling: %d\n", &gplot->scaling);
+    ignore = fscanf(fp, "Axis scaling: %d\n", &gplot->scaling);
 
     fclose(fp);
     return gplot;
